
set verify off
set echo off
set long 10000000
set linesize 32767
set pages 0
set feedback off


accept role 	prompt "Role: "


prompt
prompt


select 'create role &role;' from dual
/


prompt
prompt


select 'grant ' || privilege || ' on ' || owner || '.' || table_name || ' to ' || grantee || ';' 
from dba_tab_privs 
where grantee = upper('&role')
and grantable = 'NO'
order by owner, table_name
/


prompt
prompt



select 'grant ' || privilege || ' on ' || owner || '.' || table_name || ' to ' || grantee || ' with grant option;' 
from dba_tab_privs 
where grantee = upper('&role')
and grantable != 'NO'
order by owner, table_name
/


prompt
prompt


select 'grant ' || privilege || ' to ' || grantee || ';' 
from dba_sys_privs 
where grantee = upper('&role')
and admin_option = 'NO'
order by privilege
/


prompt
prompt


select 'grant ' || privilege || ' to ' || grantee || ' with admin option;' 
from dba_sys_privs 
where grantee = upper('&role')
and admin_option != 'NO'
order by privilege
/



prompt
prompt


select 'grant ' || granted_role || ' to ' || grantee || ';' 
from dba_role_privs 
where grantee = upper('&role')
order by grantee
/



prompt
prompt


select 'grant ' || granted_role || ' to ' || grantee || ';' 
from dba_role_privs 
where granted_role = upper('&role')
order by grantee
/



undef role

set verify on
set feedback on