set serverout on size 1000000
set head off echo off feedback off verify off
set pagesize 0
set trims on
set serveroutput off
set serveroutput on size 1000000
set linesize 5000

accept tablespace char prompt "Informe parte do nome da tablespace: "
prompt

set pause off
declare
    nome       dba_data_files.tablespace_name%type;
    arq        dba_data_files.file_name%type;
    tam        dba_data_files.bytes%type;
    status     dba_data_files.status%type;
    kbytes     smallint;
    ult_nome   dba_data_files.tablespace_name%type := ' ';
--
    cursor c_tbs is
      select distinct(d.tablespace_name),d.file_name,d.bytes,d.status
      from dba_data_files d,dba_segments s
      where d.tablespace_name != 'SYSTEM'
	  and (d.tablespace_name LIKE upper('&tablespace%'))
      order by tablespace_name;
begin
--    dbms_output.enable(50000);
--
    kbytes := 0;
--
    open c_tbs;
--
    loop
        fetch c_tbs into nome, arq, tam, status;
--
        exit when c_tbs%notfound;
--
        kbytes := tam/1024;
--
        if ult_nome <> nome then
           dbms_output.put_line('CREATE TABLESPACE '||nome||'  DATAFILE');
           dbms_output.put_line(''''||arq||''''||'  SIZE  '||kbytes||' K ONLINE; ');
        else
           dbms_output.put_line('ALTER TABLESPACE '||nome||'  ADD  DATAFILE');
           dbms_output.put_line(''''||arq||''''||'  SIZE  '||kbytes||' K; ');
        end if;
--
        ult_nome := nome;
    end loop;
--
    close c_tbs;
end;
/


prompt


set verify on